<script lang="ts">
  import { getCardSuit, getCardValue } from "../utils";

  import SuitIcon from "./SuitIcon.svelte";

  export let card: CardId;
  export let facedown: boolean = false;

  export let zero: boolean = false;

  $: suit = getCardSuit(card);
  $: cardValue = zero ? 0 : getCardValue(card);

  export let bigText: boolean = false;
</script>

<div class="outer border" class:facedown>
  <div class="inner border inner-suit-{suit}">
    {#if !facedown}
      <div class="card-suit" class:big={bigText}>
        <SuitIcon {card} />
      </div>
      <div class="card-value" class:big={bigText}>
        {cardValue}
      </div>

      {#if !bigText}
        <div class="card-art">
          <SuitIcon {card} />
        </div>
      {/if}
    {/if}
  </div>
</div>

<style lang="scss">
  .outer {
    height: 10em;
    width: 10em;
    background-color: white;
    position: relative;
    padding: 0.5em;
    filter: drop-shadow(1px 1px 1px #0003);
  }

  .inner {
    position: relative;
    height: 100%;
    border-radius: 0.25em;

    background: radial-gradient(
      circle at center,
      hsl(35, 80%, 95%),
      hsl(35, 80%, 90%)
    );
  }

  .inner-suit-A {
    background: radial-gradient(
      circle at center,
      hsl(335, 100%, 98%),
      hsl(335, 100%, 93%)
    );
  }
  .inner-suit-B {
    background: radial-gradient(
      circle at center,
      hsl(51, 100%, 80%),
      hsl(50, 100%, 75%)
    );
  }

  .inner-suit-C {
    background: radial-gradient(
      circle at center,
      hsl(81, 63%, 75%),
      hsl(81, 63%, 70%)
    );
  }

  .inner-suit-D {
    background: radial-gradient(
      circle at center,
      hsl(28deg 50% 80%),
      hsl(28deg 50% 75%)
    );
  }

  .inner-suit-E {
    background: radial-gradient(
      circle at center,
      hsl(196deg 80% 90%),
      hsl(196deg 80% 85%)
    );
  }

  .inner-suit-F {
    background: radial-gradient(
      circle at center,
      hsl(196, 100%, 100%),
      hsl(196, 100%, 97%)
    );
  }

  .inner-suit-G {
    background: radial-gradient(
      circle at center,
      hsl(277deg 50% 82%),
      hsl(277deg 50% 77%)
    );
  }

  .inner-suit-H {
    background: radial-gradient(
      circle at center,
      hsl(33deg 100% 75%),
      hsl(33deg 100% 70%)
    );
  }

  .inner-suit-I {
    background: radial-gradient(
      circle at center,
      hsl(165, 50%, 75%),
      hsl(165, 50%, 70%)
    );
  }

  .inner-suit-J {
    background: radial-gradient(
      circle at center,
      hsl(5, 100%, 88%),
      hsl(5, 100%, 83%)
    );
  }

  .facedown .inner {
    background: radial-gradient(
      circle at center,
      hsl(100, 35%, 45%),
      hsl(100, 35%, 40%)
    );
  }

  .card-value {
    line-height: 1.25;
    position: absolute;
    text-align: center;

    font-weight: 700;
    font-family: "Libre Baskerville", serif;

    &:not(.big) {
      top: 0;
      left: 0;

      width: 25%;
      font-size: 200%;
    }
    &.big {
      display: grid;
      place-content: center;
      width: 60%;
      left: 0;
      font-size: 650%;
      top: 50%;
      transform: translateY(-50%);
    }
  }

  .card-suit {
    position: absolute;
    text-align: center;

    &:not(.big) {
      font-size: 150%;
      top: 1.5em;
      left: 0;
      width: 25%;
    }
    &.big {
      display: grid;
      place-content: center;
      font-size: 350%;
      right: 0;
      top: 50%;
      width: 50%;
      transform: translateY(-55%);
    }
  }

  .card-art {
    font-size: 350%;
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);
  }
</style>
